/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.MercadoCompetidoDAO;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.MercadoCompetido;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.service.MercadoCompetidoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author rodrigo
 */
@Service("mercadoCompetidoService")
public class MercadoCompetidoServiceImpl implements MercadoCompetidoService {

    @Autowired
    private MercadoCompetidoDAO mercadoCompetidoDAO;

    public List<MercadoCompetido> obtenerTodos() {
        return mercadoCompetidoDAO.obtenerTodos();
    }

    public MercadoCompetido obtenerID(Integer id) {
        return mercadoCompetidoDAO.obtenerID(id);
    }

    @Transactional
    public MercadoCompetido suscribir(MercadoCompetido entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return mercadoCompetidoDAO.suscribir(entidad);
    }

    @Transactional
    public MercadoCompetido actualizacion(MercadoCompetido entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return mercadoCompetidoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(MercadoCompetido entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        mercadoCompetidoDAO.actualizacion(entidad);
    }

    public boolean existe(ClaseServicio claseServicio, Parada origem,
            Parada destino) {
        return mercadoCompetidoDAO.existe(claseServicio, origem, destino);
    }

    public List<MercadoCompetido> buscar(Parada origem, Parada destino) {
        return mercadoCompetidoDAO.buscar(origem, destino);
    }
}
